;;; File   : RANDOM.LSP
;;; Author : Richard A. O'Keefe
;;; Purpose: support for library(random)
;;; Updated: Friday September 11th, 1987.


(CL:IN-PACKAGE "IL")


(XCL:DEFGLOBALVAR QP.RAND.A 27134)
(XCL:DEFGLOBALVAR QP.RAND.B  9213)
(XCL:DEFGLOBALVAR QP.RAND.C 17773)

(CL:DEFUN QP.RAND.GET ()
    (LIST QP.RAND.A QP.RAND.B QP.RAND.C)
)

(CL:DEFUN QP.RAND.PUT (A B C)
    (if (AND (LEQ 0 A) (LESSP A 30269)
	     (LEQ 0 B) (LESSP B 30307)
	     (LEQ 0 C) (LESSP C 30323)) then
	(SETQ QP.RAND.A A)
	(SETQ QP.RAND.B B)
	(SETQ QP.RAND.C C)
	T
    else
	NIL
    )
)

(CL:DEFUN QP.RAND.VAL ()
    (LET ((X (PLUS
	    (QUOTIENT (SETQ QP.RAND.A
		(REMAINDER (TIMES QP.RAND.A 171) 30269)) 30269.0)
	    (QUOTIENT (SETQ QP.RAND.B
		(REMAINDER (TIMES QP.RAND.B 172) 30307)) 30307.0)
	    (QUOTIENT (SETQ QP.RAND.C
		(REMAINDER (TIMES QP.RAND.C 170) 30323)) 30323.0) )))
	(DIFFERENCE X (FIX X))
    )
)

(CL:DEFUN QP.RAND.MYB (P N)
    (LET ((X (PLUS
	    (QUOTIENT (SETQ QP.RAND.A
		(REMAINDER (TIMES QP.RAND.A 171) 30269)) 30269.0)
	    (QUOTIENT (SETQ QP.RAND.B
		(REMAINDER (TIMES QP.RAND.B 172) 30307)) 30307.0)
	    (QUOTIENT (SETQ QP.RAND.C
		(REMAINDER (TIMES QP.RAND.C 170) 30323)) 30323.0) )))
	(AND (FIXP P) (LEQ 0 P)
	     (FIXP N) (LEQ P N)
	     (LESSP (REMAINDER (FIX (TIMES X N)) N) P))
    )
)

STOP
